diff --git a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 77983d73f..3cf6d1e24 100644
--- a/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -21,6 +21,7 @@ import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.terrain.ChunkRenderer;
 import net.minecraft.client.render.tessellator.RenderBuffer;
+import net.minecraft.client.render.tessellator.TessellatorAurora;
 import net.minecraft.client.render.tessellator.TessellatorShader;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -49,6 +50,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.BoundingVolume;
 import net.minecraft.core.world.AuroraProvider;
 import net.minecraft.core.world.LevelListener;
+import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.season.Seasons;
 import net.minecraft.core.world.weather.Weather;
@@ -62,10 +64,7 @@ import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL41;
 
-import java.util.ArrayList;
-import java.util.Arrays;
-import java.util.List;
-import java.util.Random;
+import java.util.*;
 
 import static java.awt.Color.HSBtoRGB;
 
@@ -101,6 +100,7 @@ public class RenderGlobal
     private int ticks;
     private @NotNull RenderBuffer starBuffer;
     private final @NotNull RenderBuffer skyBuffer;
+    private @Nullable RenderBuffer auroraBuffer;
     private int xMinChunk;
     private int yMinChunk;
     private int zMinChunk;
@@ -292,18 +292,94 @@ public class RenderGlobal
 
         this.noEntityRenderFrames = 2;
     }
+    private final TessellatorAurora tessellatorAurora = new TessellatorAurora("Aurora Tessellator", 524288);
+    public @Nullable RenderBuffer meshAurora(@NotNull ICamera camera) {
+        if (!this.mc.gameSettings.aurora.value) return null;
+        float celestialAngle = this.world.getCelestialAngle(1f);
+        float celestialAngleO = this.world.getCelestialAngle(0);
+        if (celestialAngle < 0.25f && celestialAngleO < 0.25f) return null;
+
+        double cameraX = camera.getX(1f);
+        double cameraXO = camera.getX(0);
+        double cameraZ = camera.getZ(1f);
+        double cameraZO = camera.getZ(0);
+
+        final double scale = 1f;
+        double auroraY = (this.world.getWorldType().getMaxY() + 64f) * 2f;
+
+        // Draw pieces
+        double time = this.world.getWorldTime();
+        AuroraProvider aurora = this.world.auroraProvider;
+
+        double radius = 512;
+        long worldTime = this.world.getWorldTime();
+
+        this.tessellatorAurora.startDrawing(DrawMode.QUADS);
+        for (double x = -radius; x < radius; x += 16) {
+            for (double z = -radius; z < radius; z += 16) {
+                double posXO = cameraXO + x;
+                double posX = cameraX + x;
+                double posZO = cameraZO + z;
+                double posZ = cameraZ + z;
+
+                double distanceSq = x * x + z + z;
+                double distanceSqPercentage = distanceSq / (radius * radius * 2);
+                distanceSqPercentage = 1f - distanceSqPercentage;
+
+                if (0.3f * distanceSqPercentage < 0.01f) continue;
+                double sampleO = aurora.getAuroraPresence(posXO, posZO, worldTime, celestialAngleO);
+                double sample = aurora.getAuroraPresence(posX, posZ, worldTime + 1, celestialAngle);
+                if (sample * 0.3f * distanceSqPercentage < 0.01f) continue;
+
+                double atan = org.joml.Math.atan2(z, x);
+                double rotationX = Math.cos(org.joml.Math.PI_OVER_2_f + atan);
+                double rotationZ = Math.sin(org.joml.Math.PI_OVER_2_f + atan);
+
+                for (int i = 0; i < 2; i++) {
+                    for (int j = 0; j < 2; j++) {
+                        double xOff = i * 8;
+                        double zOff = j * 8;
+
+                        double aurX = (x + xOff) * scale;
+                        double aurY = (auroraY * scale  * scale) + aurora.getAuroraHeightOffset((posX + xOff), (posZ + zOff), time + 1);
+                        double aurZ = (z + zOff) * scale;
+
+                        double aurYO = (auroraY * scale  * scale) + aurora.getAuroraHeightOffset((posX + xOff), (posZ + zOff), time);
+
+                        float r = aurora.getAuroraRedOffset((posX + xOff), (posZ + zOff), time + 1);
+                        float g = aurora.getAuroraGreenOffset((posX + xOff), (posZ + zOff), time + 1);
+                        float b = aurora.getAuroraBlueOffset((posX + xOff), (posZ + zOff), time + 1);
+
+                        float ro = aurora.getAuroraRedOffset((posXO + xOff), (posZO + zOff), time);
+                        float go = aurora.getAuroraGreenOffset((posXO + xOff), (posZO + zOff), time);
+                        float bo = aurora.getAuroraBlueOffset((posXO + xOff), (posZO + zOff), time);
+
+                        renderAuroraBeam(this.tessellatorAurora,
+                            aurX, aurY, aurZ,
+                            aurX, aurYO, aurZ,
+                            rotationX, rotationZ,
+                            r, g, b,
+                            ro, go, bo, scale,
+                            (float) (sample * 0.3f * distanceSqPercentage),
+                            (float) (sampleO * 0.3f * distanceSqPercentage));
+                    }
+                }
+            }
+        }
+        return this.tessellatorAurora.record(GL41.glGenVertexArrays(), GL41.glGenBuffers());
+    }
 
     public void renderAurora(ICamera camera, float partialTick) {
         float celestialAngle = this.world.getCelestialAngle(partialTick);
         if (celestialAngle < 0.25f) return;
 
-        double cameraX = camera.getX(partialTick);
         double cameraY = camera.getY(partialTick);
-        double cameraZ = camera.getZ(partialTick);
-        double cameraYaw = camera.getYRot(partialTick);
-        double temperature = this.world.getBlockTemperature((int) cameraX, (int) cameraZ);
+
+        TilePos cameraBlock = camera.getTilePos(partialTick);
+
+        double temperature = this.world.getBlockTemperature(cameraBlock);
         float mult = 0.0f;
-        if ((temperature <= 0.4f || this.world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS) && this.world.isChunkLoaded((int) cameraX, (int) cameraZ)) {
+        if ((temperature <= 0.4f || this.world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_WINTER_ENDLESS) && this.world.isChunkLoaded(new ChunkPos(cameraBlock))) {
             // temperature from 0.0f to 0.4f
             temperature /= 0.4f;
             // temperature from 0.0f to 1.0f
@@ -332,73 +408,70 @@ public class RenderGlobal
         double totalDelta = this.targetAuroraBrightness - this.auroraBrightness;
         double auroraBrightnessDelta = totalDelta / 100;
         this.auroraBrightness += auroraBrightnessDelta * partialTick;
+        if (this.auroraBrightness <= 0) return;
 
-        GLRenderer.enableState(State.BLEND);
-        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         GLRenderer.globalSetLightEnabled(false);
-        GLRenderer.enableState(State.DEPTH_TEST);
-        GLRenderer.setDepthFunc(CompareFunc.ALWAYS);
+        GLRenderer.pushFrame();
+        GLRenderer.setColor4f(1f, 1f, 1f, (float) this.auroraBrightness);
+        GLRenderer.setShader(Shaders.AURORA);
+        float fov = GLRenderer.projectionM4f().perspectiveFov();
+        GLRenderer.projectionM4f().identity().perspective(fov, (float) this.mc.gameWindow.getWidthPixels() / (float) this.mc.gameWindow.getHeightPixels(), 0.05F, 2000); // Extend out farplane so turning camera doesn't clip aurora
+        GLRenderer.modelM4f().translate(0, (float) -cameraY, 0);
+        GLRenderer.getFogState().disable();
+        GLRenderer.setAlphaTest(0.0f);
+        GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+        GLRenderer.enableState(State.BLEND);
+        GLRenderer.disableState(State.CULL_FACE);
+        GLRenderer.disableState(State.DEPTH_TEST);
 
-        final double scale = 1f;
-        double auroraY = (this.world.getWorldType().getMinY() + this.world.getWorldType().getYRange() + 64f) * 2f;
 
-        // Draw pieces
-        double rotationX = Math.cos(((cameraYaw * Math.PI) / 180D));
-        double rotationZ = Math.sin(((cameraYaw * Math.PI) / 180D));
+        if (this.auroraBuffer != null) {
+            this.textureManager.bindTexture(this.textureManager.loadTexture("/assets/minecraft/textures/environment/aurora.png"));
+            GLRenderer.render(this.auroraBuffer);
+        }
 
-        this.textureManager.bindTexture(this.textureManager.loadTexture("/assets/minecraft/textures/environment/aurora.png"));
-        double time = this.world.getWorldTime() + partialTick;
-        AuroraProvider aurora = this.world.auroraProvider;
+        GLRenderer.popFrame();
+        GLRenderer.globalSetLightEnabled(false);
+    }
 
-        double radius = 512;
-        long worldTime = this.world.getWorldTime();
+    private void renderAuroraBeam(@NotNull TessellatorAurora tessellator,
+                                  double x, double y, double z,
+                                  double xo, double yo, double zo,
+                                  double xOffset, double zOffset,
+                                  float redOffset, float greenOffset, float blueOffset,
+                                  float redOffsetO, float greenOffsetO, float blueOffsetO,
+                                  double scale,
+                                  float transparency, float transparencyO) {
+        float width = 16f;
 
-        TessellatorGeneral t = GLRenderer.getTessellator();
-        t.startDrawingQuads();
-        for (double x = -radius; x < radius; x += 16) {
-            for (double z = -radius; z < radius; z += 16) {
-                double posX = cameraX + x;
-                double posZ = cameraZ + z;
+        float r = org.joml.Math.clamp(0, 1, redOffset);
+        float g = org.joml.Math.clamp(0, 1, (255 / 255f) + greenOffset);
+        float b = org.joml.Math.clamp(0, 1, (127 / 255f) + blueOffset);
 
-                double distanceSq = x * x + z + z;
-                double distanceSqPercentage = distanceSq / (radius * radius + radius * radius);
-                distanceSqPercentage = 1f - distanceSqPercentage;
+        float rO = org.joml.Math.clamp(0, 1, redOffsetO);
+        float gO = org.joml.Math.clamp(0, 1, (255 / 255f) + greenOffsetO);
+        float bO = org.joml.Math.clamp(0, 1, (127 / 255f) + blueOffsetO);
 
-                double sample = aurora.getAuroraPresence(posX, posZ, worldTime, celestialAngle) * this.auroraBrightness;
-                if (sample * 0.3f * distanceSqPercentage < 0.01f) continue;
+        tessellator.addVertex(
+            x - xOffset * scale * width, y - scale * 256, z - zOffset * scale * width,
+            xo - xOffset * scale * width, yo - scale * 256, zo - zOffset * scale * width,
+            r, g, b, transparency, rO, gO, bO, transparencyO, 1, 1);
 
-                for (int i = 0; i < 2; i++) {
-                    for (int j = 0; j < 2; j++) {
-                        double xOff = i * 8;
-                        double zOff = j * 8;
-                        renderAuroraBeam(t,
-                            (x + xOff) * scale,
-                            (auroraY * scale - cameraY * scale) + aurora.getAuroraHeightOffset((posX + xOff), (posZ + zOff), time),
-                            (z + zOff) * scale, rotationX,
-                            rotationZ,
-                            aurora.getAuroraRedOffset((posX + xOff), (posZ + zOff), time),
-                            aurora.getAuroraGreenOffset((posX + xOff), (posZ + zOff), time),
-                            aurora.getAuroraBlueOffset((posX + xOff), (posZ + zOff), time), scale,
-                            (float) (sample * 0.3f * distanceSqPercentage));
-                    }
-                }
-            }
-        }
-        t.draw();
+       tessellator.addVertex(
+           x - xOffset * scale * width, y + scale, z - zOffset * scale * width,
+           xo - xOffset * scale * width, yo + scale, zo - zOffset * scale * width,
+           r, g, b, transparency, rO, gO, bO, transparencyO, 1, 0);
 
-        GLRenderer.setDepthFunc(CompareFunc.LESS_EQUAL);
-        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
-        GLRenderer.disableState(State.BLEND);
-        GLRenderer.globalSetLightEnabled(false);
-    }
+       tessellator.addVertex(
+           x + xOffset * scale * width, y + scale, z + zOffset * scale * width,
+           xo + xOffset * scale * width, yo + scale, zo + zOffset * scale * width,
+           r, g, b, transparency, rO, gO, bO, transparencyO, 0, 0);
+
+       tessellator.addVertex(
+           x + xOffset * scale * width, y - scale * 256, z + zOffset * scale * width,
+           xo + xOffset * scale * width, yo - scale * 256, zo + zOffset * scale * width,
+           r, g, b, transparency, rO, gO, bO, transparencyO, 0, 1);
 
-    private void renderAuroraBeam(@NotNull TessellatorGeneral tessellator, double x, double y, double z, double xOffset, double zOffset, float redOffset, float greenOffset, float blueOffset, double scale, float transparency) {
-        float width = 16f;
-        tessellator.setColor4f(0 / 255f + redOffset, 255 / 255f + greenOffset, 127 / 255f + blueOffset, transparency);
-        tessellator.addVertexWithUV(x - xOffset * scale * width, y - scale * 256, z - zOffset * scale * width, 1.0, 1.0);
-        tessellator.addVertexWithUV(x - xOffset * scale * width, y + scale, z - zOffset * scale * width, 1.0, 0.0);
-        tessellator.addVertexWithUV(x + xOffset * scale * width, y + scale, z + zOffset * scale * width, 0.0, 0.0);
-        tessellator.addVertexWithUV(x + xOffset * scale * width, y - scale * 256, z + zOffset * scale * width, 0.0, 1.0);
     }
 
     public void renderEntities(ICamera camera, float partialTick) {
@@ -406,8 +479,8 @@ public class RenderGlobal
             this.noEntityRenderFrames--;
             return;
         }
-        TileEntityRenderDispatcher.instance.cacheActiveRenderInfo(this.world, camera, partialTick);
-        EntityRendererDispatcher.instance.cacheActiveRenderInfo(this.world, camera, partialTick);
+        TileEntityRenderDispatcher.instance.cacheActiveRenderInfo(camera, partialTick);
+        EntityRendererDispatcher.instance.cacheActiveRenderInfo(camera, partialTick);
         this.totalEntities = 0;
         this.renderedEntities = 0;
         this.culledEntities = 0;
@@ -460,7 +533,7 @@ public class RenderGlobal
         // DO NOT TURN THIS INTO A FOREACH EITHER
         for (int i = 0, tileEntitiesSize = this.renderableTileEntities.size(); i < tileEntitiesSize; i++) {
             TileEntity tileEntity = this.renderableTileEntities.get(i);
-            TileEntityRenderDispatcher.instance.renderTileEntity(tessellator, camera, tileEntity, partialTick);
+            TileEntityRenderDispatcher.instance.renderTileEntity(tessellator, camera, this.world, tileEntity, partialTick);
         }
     }
 
@@ -602,6 +675,12 @@ public class RenderGlobal
         this.cloudOffsetZ += this.cloudVelocityZ;
 
         this.ticks++;
+
+        if (this.auroraBuffer != null) {
+            this.auroraBuffer.delete();
+            this.auroraBuffer = null;
+        }
+        this.auroraBuffer = meshAurora(this.mc.activeCamera);
     }
 
     public void renderSky(float partialTick) {
@@ -1077,16 +1156,12 @@ public class RenderGlobal
             TextureRegistry.worldAtlas.bind();
             GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 0.25F);
             GLRenderer.pushFrame();
-            int k = this.world.getBlockId(tileHit.tilePos);
-            Block<?> block = k <= 0 ? null : Blocks.blocksList[k];
+            Block<?> block = this.world.getBlockType(tileHit.tilePos);
             GLRenderer.setPolygonOffset(-3F, -3F);
             GLRenderer.enableState(State.POLYGON_OFFSET_FILL);
             double x = camera.getX(partialTick);
             double y = camera.getY(partialTick);
             double z = camera.getZ(partialTick);
-            if (block == null) {
-                block = Blocks.STONE;
-            }
             tessellator.startDrawingQuads();
             tessellator.setTranslation(-x, -y, -z);
             tessellator.lockColor();
@@ -1122,7 +1197,7 @@ public class RenderGlobal
 
             if (hitResult instanceof HitResult.Tile hitTile) {
                 float expand = 0.002F;
-                Block<?> block = this.world.getBlock(hitTile.tilePos);
+                Block<?> block = this.world.getBlockType(hitTile.tilePos);
                 if (block != null) {
                     BoundingVolume volume = block.getBoundingVolume(this.world, hitTile.tilePos);
                     if (volume != null) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
index 4ac2f973d..198198164 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TextureManager.java
@@ -416,7 +416,6 @@ public class TextureManager {
         this.mc.mainMenuBackground.refresh(errors);
 		
         Colorizers.reload();
-        Colorizers.update(true);
 
         this.mc.worldRenderer.lightmapHelper.setup();
 	}
diff --git a/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
index 5ad45565f..ac82c1181 100644
--- a/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/TileEntityRenderDispatcher.java
@@ -29,7 +29,6 @@ public final class TileEntityRenderDispatcher
     public final @NotNull TexturePackList packList;
     private final @NotNull FontRenderer font;
     public final @NotNull GameSettings settings;
-    public @Nullable World world;
     public @Nullable ICamera camera;
     public float viewLerpYaw = 0;
     public float viewLerpPitch = 0;
@@ -95,15 +94,8 @@ public final class TileEntityRenderDispatcher
         return getRenderer(tileEntity) != null;
     }
 
-    public void cacheActiveRenderInfo(final @NotNull World world, final @NotNull ICamera camera, final float partialTick)
+    public void cacheActiveRenderInfo(final @NotNull ICamera camera, final float partialTick)
     {
-        if(this.world != world) {
-            for (final @Nullable TileEntityRenderer<?> renderer : this.renderers.values()) {
-                if (renderer == null) continue;
-                renderer.onWorldChanged(world);
-            }
-        }
-        this.world = world;
         this.camera = camera;
         this.viewLerpYaw = (float) camera.getYRot(partialTick);
         this.viewLerpPitch = (float) camera.getXRot(partialTick);
@@ -112,16 +104,22 @@ public final class TileEntityRenderDispatcher
         this.viewLerpPosZ = camera.getZ(partialTick);
     }
 
-    public <T extends TileEntity> void renderTileEntity(final @NotNull TessellatorGeneral tessellator, final ICamera camera, final @NotNull T tileEntity, final float partialTick)
+    public void onWorldChanged(@NotNull World world) {
+        for (final @Nullable TileEntityRenderer<?> renderer : this.renderers.values()) {
+            if (renderer == null) continue;
+            renderer.onWorldChanged(world);
+        }
+    }
+
+    public <T extends TileEntity> void renderTileEntity(final @NotNull TessellatorGeneral tessellator, final @NotNull ICamera camera, final @NotNull World world, final @NotNull T tileEntity, final float partialTick)
     {
         final TileEntityRenderer<T> renderer = TileEntityRenderDispatcher.instance.getRenderer(tileEntity);
 
         if (renderer == null) return;
-        if(tileEntity.getDistanceFrom(this.viewLerpPosX, this.viewLerpPosY, this.viewLerpPosZ) > 4096D * settings.entityRenderDistance.value) return;
+        if(tileEntity.getDistanceFrom(this.viewLerpPosX, this.viewLerpPosY, this.viewLerpPosZ) > 4096D * this.settings.entityRenderDistance.value) return;
         if (!renderer.isVisible(tileEntity, camera, partialTick)) return;
 
-        assert this.world != null;
-        GLRenderer.setLightmapCoord1i(this.world.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
+        GLRenderer.setLightmapCoord1i(world.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0));
         GLRenderer.setColor3f(1f, 1f, 1f);
         renderer.doRender(tessellator,
             tileEntity,
diff --git a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 130c9ce4e..4c36e0855 100644
--- a/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -129,8 +129,8 @@ public class WorldRenderer {
             return;
         }
 
-        final double blockReach = this.mc.playerController.getBlockReachDistance();
-        final double entityReach = this.mc.playerController.getEntityReachDistance();
+        final double blockReach = this.mc.thePlayer.getGamemode().getBlockReachDistance();
+        final double entityReach = this.mc.thePlayer.getGamemode().getEntityReachDistance();
 
         Vector3dc pos1 = this.mc.thePlayer.getPosition(partialTicks, true);
         Vector3dc look = this.mc.thePlayer.getViewVector(partialTicks);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
index 5cda20536..bf48ba4b2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/color/BlockColorDispatcher.java
@@ -1,23 +1,32 @@
 package net.minecraft.client.render.block.color;
 
+import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public final class BlockColorDispatcher
-    extends Dispatcher<Block<?>, BlockColor>
-{
+    extends Dispatcher<Block<?>, BlockColor> {
     private static final BlockColorDispatcher instance = new BlockColorDispatcher();
     private static final BlockColor defaultColor = new BlockColorDefault();
 
-    public static BlockColorDispatcher getInstance()
-    {
+    public static BlockColorDispatcher getInstance() {
         return instance;
     }
 
-    private BlockColorDispatcher()
-    {
+    private BlockColorDispatcher() {
+        reload();
+    }
+
+    public void onWorldChanged(@NotNull World world) {
+        reload();
+    }
+
+    public void reload() {
+        this.dispatches.clear();
         addDispatch(Blocks.ALGAE, new BlockColorCustom(Colorizers.grass));
         addDispatch(Blocks.FLUID_WATER_STILL, new BlockColorWater(Colorizers.water));
         addDispatch(Blocks.FLUID_WATER_FLOWING, new BlockColorWater(Colorizers.water));
@@ -45,9 +54,9 @@ public final class BlockColorDispatcher
         addDispatch(Blocks.NETHERRACK_CRYSTALLINE, new BlockColorCrystal(Colorizers.crystal));
     }
 
+
     @Override
-    protected BlockColor getDefault()
-    {
+    protected BlockColor getDefault() {
         return defaultColor;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
index 7ce4d673a..d16c5cbda 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModel.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
@@ -36,6 +37,9 @@ public abstract class BlockModel<T extends BlockLogic> {
     public abstract @Nullable IconCoordinate getOverlayTexture(int meta);
     public abstract int particleColorIndex(@NotNull WorldSource worldSource, @NotNull TilePosc tilePos, @NotNull Side side, int meta);
 
+    public void onWorldChanged(@NotNull World world) {
+    }
+
     public boolean isRetro() {
         return Minecraft.getMinecraft().currentWorld != null && Minecraft.getMinecraft().currentWorld.isRetro();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 295654d4c..7dc2e7fcf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -25,6 +25,7 @@ import net.minecraft.client.render.block.model.generic.BlockModelGenericFenceThi
 import net.minecraft.client.render.block.model.generic.BlockModelGenericFlowerStackable;
 import net.minecraft.client.render.block.model.generic.BlockModelGenericFullyRotatable;
 import net.minecraft.client.render.block.model.generic.BlockModelGenericFurnace;
+import net.minecraft.client.render.block.model.generic.BlockModelGenericGrass;
 import net.minecraft.client.render.block.model.generic.BlockModelGenericLayer;
 import net.minecraft.client.render.block.model.generic.BlockModelGenericLever;
 import net.minecraft.client.render.block.model.generic.BlockModelGenericMatcher;
@@ -62,15 +63,14 @@ import net.minecraft.client.util.dispatch.Dispatcher;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 import org.useless.dragonfly.data.block.mojang.BlockModelMojangData;
 
 public final class BlockModelDispatcher
-    extends Dispatcher<Block<?>, BlockModel<?>> {
+    extends Dispatcher<@NotNull Block<?>, @NotNull BlockModel<?>> {
     private static final Logger LOGGER = LogUtils.getLogger();
-    private static final Side[] S_TB = {Side.TOP, Side.BOTTOM};
-    private static final Side[] S_SIDES = {Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST};
 
     private static BlockModelDispatcher instance = new BlockModelDispatcher();
 
@@ -80,14 +80,14 @@ public final class BlockModelDispatcher
 
     public static BlockModelEmpty<?> modelEmpty = new BlockModelEmpty<>(null);
 
-    public void addDispatch(final BlockModel<?> model) {
+    public void addDispatch(final @NotNull BlockModel<?> model) {
         addDispatch(model.block, model);
     }
 
     @Override
-    public void addDispatch(final Block<?> key, final BlockModel<?> value) {
+    public void addDispatch(final @NotNull Block<?> key, final @NotNull BlockModel<?> value) {
         if (hasDispatch(key)) {
-            throw new IllegalArgumentException("Block '" + key.toString() + "' already assigned a model!");
+            throw new IllegalArgumentException("Block '" + key + "' already assigned a model!");
         }
         this.dispatches.put(key, value);
     }
@@ -111,6 +111,12 @@ public final class BlockModelDispatcher
         reload();
     }
 
+    public void onWorldChanged(@NotNull World world) {
+        for (BlockModel<?> model : this.dispatches.values()) {
+            model.onWorldChanged(world);
+        }
+    }
+
     public void reload() {
         BlockModelMojangData.Cache.resetCache();
         this.dispatches.clear();
@@ -244,7 +250,7 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelGlass<>(Blocks.GLASS_TINTED, "minecraft:block/glass_tinted/").onRenderLayer(1).setAllTextures("minecraft:block/glass_tinted"));
         addDispatch(new BlockModelGeneric<>(Blocks.GLASS_STEEL, loadDataModel("minecraft:block/glass_steel")).forceCullSelf(true));
 
-        addDispatch(new BlockModelGeneric<>(Blocks.GRASS, loadDataModel("minecraft:block/grass")));
+        addDispatch(new BlockModelGenericGrass<>(Blocks.GRASS));
         addDispatch(new BlockModelGeneric<>(Blocks.GRASS_RETRO, loadDataModel("minecraft:block/grass_retro")));
         addDispatch(new BlockModelGeneric<>(Blocks.GRASS_SCORCHED, loadDataModel("minecraft:block/grass_scorched")));
         addDispatch(new BlockModelGeneric<>(Blocks.PATH_DIRT, loadDataModel("minecraft:block/grass_path")));
@@ -279,14 +285,14 @@ public final class BlockModelDispatcher
             .setTex("minecraft:block/water_still", Side.TOP));
         addDispatch(new BlockModelFluid<>(Blocks.FLUID_WATER_STILL)
             .onRenderLayer(1)
-            .setTex("minecraft:block/water_still", S_TB)
-            .setTex("minecraft:block/water_flowing", S_SIDES));
+            .setTex("minecraft:block/water_still", Side.TOP, Side.BOTTOM)
+            .setTex("minecraft:block/water_flowing", Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST));
         addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_FLOWING)
             .setAllTextures("minecraft:block/lava_flowing")
             .setTex("minecraft:block/lava_still", Side.TOP));
         addDispatch(new BlockModelFluid<>(Blocks.FLUID_LAVA_STILL)
-            .setTex("minecraft:block/lava_still", S_TB)
-            .setTex("minecraft:block/lava_flowing", S_SIDES));
+            .setTex("minecraft:block/lava_still", Side.TOP, Side.BOTTOM)
+            .setTex("minecraft:block/lava_flowing", Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST));
 
         addDispatch(new BlockModelGenericAxis<>(Blocks.LOG_OAK, loadDataModel("minecraft:block/log/oak")));
         addDispatch(new BlockModelGenericAxis<>(Blocks.LOG_PINE, loadDataModel("minecraft:block/log/pine")));
@@ -407,9 +413,6 @@ public final class BlockModelDispatcher
 
         addDispatch(new BlockModelGenericLever<>(Blocks.LEVER_COBBLE_STONE).render3D(false));
 
-        final float f = 0.5F;
-        final float f1 = 0.125F;
-        final float f2 = 0.5F;
         addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_STONE, "minecraft:block/pressure_plate/stone"));
         addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_PLANKS_OAK, "minecraft:block/pressure_plate/planks/oak"));
         addDispatch(new BlockModelGenericPressurePlate<>(Blocks.PRESSURE_PLATE_COBBLE_STONE, "minecraft:block/pressure_plate/cobbled_stone"));
